#include "PageTable.h"

int
PageTable::Get( int Index )
{
	for ( int i = 0, count = 0 ; i < 4 ; i++ )
	{
		// Possibly an error point
		if ( PageIdTable[i] != -1 ) 
		{
			if ( count++ == Index ) 
				return PageIdTable[i] ;
		}
	}

	return -1 ; 
}

int
PageTable::GetPageId(int Quadrant)
{
	for ( int i = 0 ; i < 4 ; i++ )
	{
		if ( PageIdTable[i] != -1 )
		{
			for ( int j = 0 ; j < 4 ; j++ )
			{
				if ( Quadrant == QuadrantTable[i][j] ) 
					return PageIdTable[i] ; 
			}
		}
	}

	return PAGE_ID_NOT_FOUND ; 
}

int
PageTable::GetQuadrants(int PageId, int* Quadrants )
{
	for ( int i = 0 ; i < 4 ; i++ )
	{
		if ( PageId ==  PageIdTable[i] )
		{
			int n = 0 ;

			// Copy the Process Ids into the array given by the user  
			for ( int j = 0 ; j < 4 ; j++ )
			{
				if ( QuadrantTable[i][j] != -1 ) 
				{
					Quadrants[n] = QuadrantTable[i][j] ;

					n++ ;
				}
			}

			return n ;
		}
	}

	return PAGE_ID_NOT_FOUND ;  
}
					
int
PageTable::InsertPageId( int PageId )
{
	for ( int i = 0 ; i < 4 ; i++ )
	{
		if ( PageId == PageIdTable[i] )
		{
			return PAGE_ID_ALREADY_EXISTS ; 		
		}
		else if ( PageIdTable[i] == -1 ) 
		{
			PageIdTable[i] = PageId ; 

			return 0 ; 	
		}
	}

	return -1 ;  
}

int
PageTable::InsertQuadrant( int PageId, int Quadrant )
{
	// Assumes that the PageId exists in the PageId Table 

	for ( int i = 0 ; i < 4 ; i++ )
	{
		if ( PageId == PageIdTable[i] )
		{
			for ( int j = 0 ; j < 4 ; j++ ) 	
			{
				if ( Quadrant == QuadrantTable[i][j] )
				{
					return QUADRANT_ALREADY_EXISTS ;
				}
				else if ( QuadrantTable[i][j] == -1 )
				{
					QuadrantTable[i][j] = Quadrant ;

					return 0 ;
				}
			}

			return -1 ; 
		}
	}

	return PAGE_ID_NOT_FOUND ; 
}	

int
PageTable::GetNumberOfPages()
{
	int count = 0 ;

	for ( int i = 0 ; i < 4 ; i++ )
	{
		if ( PageIdTable[i] != -1 )
		{
			count++ ;
		}
	}

	return count ;
}

/*
main()
{
	PageTable LocalPageTable ;

	LocalPageTable.InsertPageId(5) ;

	LocalPageTable.InsertQuadrant(5,10) ;

	LocalPageTable.InsertQuadrant(5,20) ;

	LocalPageTable.InsertPageId(10) ;

	LocalPageTable.InsertQuadrant(10,25) ;

	int quadrants[4] ;

	LocalPageTable.GetQuadrants(5,quadrants) ; 
}
*/
