#include <stdlib.h>
#include <stdio.h>
#include <limits.h>
#include <iostream.h>
#include <math.h>
#include <fcntl.h>

#include "standard.h"
#include "qtree.h"

int fDesc;

Point_t *points;


extern int random() ;

/*
 * returns 1 if morton(p1) >= morton(p2), 0 otherwise 
 */
int compare(Point_t p1, Point_t p2)
{
  unsigned int dx = (unsigned)p1.x ^ (unsigned)p2.x;
  unsigned int dy = (unsigned)p1.y ^ (unsigned)p2.y;
  unsigned int d  = dx ^ dy;
  return ((d<dx && d<dy) || dy>dx) ? p1.y >= p2.y : p1.x >= p2.x;
}


int mycompare(const void *p1, const void *p2)
{
Point_t pp1,pp2;
 
 pp1.x = ((Point_t*)p1)->x;
 pp1.y = ((Point_t*)p1)->y;
 pp2.x = ((Point_t*)p2)->x;
 pp2.y = ((Point_t*)p2)->y;

 if (compare(pp1, pp2) && compare(pp2, pp1))
  return 0;
 if (!compare(pp1, pp2))
  return -1;
 return 1;
}

int bload(int count)
{
int i = 0;
int fd;
int nbytes;
Point_t pt;

  points = (Point_t*)malloc(count*sizeof(Point_t));

  while(i < count) 	/* generating 'count' points */
  {
    Point_t pt(random()%100000000, random()%100000000); 
    points[i++] = pt;
  }
  qsort(points, count, sizeof(Point_t), mycompare);/*morton sort the points*/
  i = 0;
  while (i < count)
  {
    pt.x = points[i].x;
    pt.y = points[i].y;
    nbytes = write(fDesc,(char*)&pt,sizeof(pt));
    if (nbytes != sizeof(Point_t))
    {
       fprintf(stderr,"writing record %d failed:", i);
       perror("");
       return 0;
    }
    /* print out the points as and when writing into the file */
    fprintf(stdout, "(%d,%d)\n", pt.x, pt.y);
    i++;
  }  
  return 1;
}   

void usage()
{
  fprintf(stderr, "Usage: bload <loadfile> <count>\n");
  exit(-1);
}
main(int argc, char **argv)
{
  if (argc<3)
   usage();
  fprintf(stderr, "Creating file %s for bulk loading with %d records\n", 
                   argv[argc-2], atoi(argv[argc-1]));
  if ( (fDesc = open(argv[argc-2], O_WRONLY, 0)) < 0)
  {
    fprintf(stderr,"Error opening load file %s:", argv[argc-2]);
    perror("");
    exit(-1);
  }
  if (!bload(atoi(argv[argc-1])))
   fprintf(stderr, "bulk load failed\n");
  else
   fprintf(stderr, "done..\n");
  close(fDesc);
  
}
  
