#if !defined(__STACK_H)
#define __STACK_H

template <class StackElementType>
class Stack_t {
  private:
    enum { stk_chunk = 100 } ;
    int _top;
    StackElementType _stk[stk_chunk];
    StackElementType* _indirect[stk_chunk];


  public:

    Stack_t()
    {
    	_top = 0;
    	for (int i=0; i<stk_chunk; i++) 
    	{
	    _indirect[i] = NULL;
    	}
    }
	
    ~Stack_t()
    {
   	while ( _top > 0 ) 
   	{
		pop();
   	}
    }	

    StackElementType& push(const StackElementType& anElement) 
    {
	Assert(! is_full());
	if (_top < stk_chunk) 
	{
		_stk[_top++] = anElement ; 
		
		return _stk[_top - 1] ; 
	}	
	else
	{
		int pos = _top / stk_chunk - 1;
		int off = _top % stk_chunk;
		if (!_indirect[pos])
			_indirect[pos] = new StackElementType[stk_chunk];
		_indirect[pos][off] = anElement;
		_top++;
		return _indirect[pos][off] ; 
	}
    }

    StackElementType pop() 
    {
	Assert(! is_empty());
	if (_top <= stk_chunk) return _stk[--_top];
	else 
	{
	    _top--;
	    StackElementType anElement = _indirect[_top/stk_chunk-1][_top%stk_chunk];
	    if (_top>=stk_chunk && _top%stk_chunk==0) 
	    {
		delete _indirect[_top/stk_chunk - 1];
		_indirect[_top/stk_chunk - 1] = 0;
	    }
	    return anElement;
	}
    }

    void empty_all()
    {
    	while (_top > 0) 
    	{
        	 _top--;

	 	if (_top>=stk_chunk && _top%stk_chunk==0) 
	 	{
			delete _indirect[_top/stk_chunk - 1];
		}
    	}
    }	

	    
    bool is_full()    { return _top >= stk_chunk+stk_chunk*stk_chunk; }
    bool is_empty()   { return _top == 0; }
};

struct qt_cursor_t {
    Rect_t			qrange;
    Stack_t<page_stk_entry>     page_stk;
    Stack_t<slot_stk_entry>     slot_stk;

    int				num_slot;	// leaf slot number in the current page 
    QPage_t*			page;

    qt_cursor_t() { num_slot = SINil; page = NULL; }
};

#endif 
