#include <iostream.h>
struct Point_t
{
	unsigned int x;
	unsigned int y;
	Point_t(unsigned xx, unsigned yy) :x(xx), y(yy) {}
};
/* returns 1 if p1 >= p2 in Morton order 0 otherwise */
int compare(Point_t &p1, Point_t &p2)
{
	unsigned int dx = p1.x ^ p2.x;
	unsigned int dy = p1.y ^ p2.y;
	unsigned int d  = dx ^ dy;
	return ((d<dx && d<dy) || dy>dx)? p1.y>=p2.y : p1.x>=p2.x;
}

int scompare(Point_t &p1, Point_t &p2)
{
	for (int mask = (1<<30); mask; mask = mask >> 1)
	{
		if ((p1.y & mask) > (p2.y & mask)) return  1;
		if ((p1.y & mask) < (p2.y & mask)) return -1;
		if ((p1.x & mask) > (p2.x & mask)) return  1;
		if ((p1.x & mask) < (p2.x & mask)) return -1;
	}
	return 0;
}

int main()
{
	for (unsigned int i1 = 0; i1 < 128; i1++)
	{
		write(1, ".", 1);
		for (unsigned int j1 = 0; j1 < 128; j1++)
		{
			Point_t p1(i1<<24, j1<<24);
			for (unsigned int i2 = 0; i2 < 128; i2++)
			{
				for (unsigned int j2 = 0; j2 < 128; j2++)
				{
					Point_t p2(i2<<24, j2<<24);
					if (compare(p1, p2) && (scompare(p1, p2) < 0))
						cerr << "Error in program" << p1.x<<' '<<p1.y<<' '<<p2.x<<' '<<p2.y<<endl;
				}
			}
		}
	}
	cerr << "It works" << endl;
}


