#include <stdlib.h>
#include <stdio.h>
#include <limits.h>
#include <iostream.h>
#include <math.h>
#include <fcntl.h>

#include "standard.h"
#include "qtree.h"

int fDesc;

int bload(int count)
{
int i = 0;
int fd;
int nbytes;

  while(i < count)
  {
    Point_t pt(random(), random()); 
    nbytes = write(fDesc,(char*)&pt,sizeof(pt));
    if (nbytes != sizeof(Point_t))
    {
       fprintf(stderr,"writing record %d failed:", i);
       perror("");
       return 0;
    }
    i++;
  }
  return 1;
}

void usage()
{
  fprintf(stderr, "Usage: bload <loadfile> <count>\n");
  exit(-1);
}
main(int argc, char **argv)
{
  if (argc<3)
   usage();
  fprintf(stderr, "Creating file %s for bulk loading with %d records\n", 
                   argv[argc-2], atoi(argv[argc-1]));
  if ( (fDesc = open(argv[argc-2], O_WRONLY, 0)) < 0)
  {
    fprintf(stderr,"Error opening load file %s:", argv[argc-2]);
    perror("");
    exit(-1);
  }
  if (!bload(atoi(argv[argc-1])))
   fprintf(stderr, "bulk load failed\n");
  else
   fprintf(stderr, "done..\n");
  close(fDesc);
  
}
  
