#ifndef _QUADSORT_H_
#define _QUADSORT_H_

#include <sys/types.h>
#include <unistd.h>

int compare(const Point_t *p1, const Point_t *p2);

const int oneRecSize = -sizeof(Point_t);

#define UNGET_ONEREC(fd)   ( lseek(fd,(long)oneRecSize,SEEK_CUR) )
#define UNGET_TWORECS(fd)  ( lseek(fd,(long)2*oneRecSize,SEEK_CUR) )


#define CHECK_MALLOC(x)  { if (!(x)) {\
                           fprintf(stderr,"Memory alloc error\n"); \
                          exit(-1); }\
                         }
int isValid(const Point_t *pt);

extern Point_t *points;
class Quadfile_t
{
private:
  int fDesc;
  Point_t *first;
  Point_t *second;
  
public:
 /*
  * Constructor initializes the sort file ,
  * and buffers the first and second records in the sorted file
  */
  Quadfile_t(int fd, Point_t pt1, Point_t pt2);
  ~Quadfile_t();
  int peek(const Point_t &pt);
  int move(const Point_t &pt);
};          

#endif
